"use strict";

var _path = require("path");

var _promiseWrap = _interopRequireDefault(require("./lib/promise-wrap"));

var _auth = require("./lib/auth");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var lnPath = process.env.LN_PATH || (0, _path.join)(require('os').homedir(), '.lightning'),
    apiToken = (0, _auth.getToken)(process.env.API_TOKEN, process.env.COOKIE_FILE);

_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
  var db, ln, lnconf, model, auth, payListen, app, server;
  return regeneratorRuntime.wrap(function _callee2$(_context2) {
    while (1) {
      switch (_context2.prev = _context2.next) {
        case 0:
          db = require('knex')(require('../knexfile'));
          ln = require('clightning-client')(lnPath);
          _context2.next = 4;
          return ln.listconfigs();

        case 4:
          lnconf = _context2.sent;
          _context2.next = 7;
          return db.migrate.latest({
            directory: (0, _path.join)(__dirname, '../migrations')
          });

        case 7:
          model = require('./model')(db, ln), auth = (0, _auth.authMiddleware)('api-token', apiToken), payListen = require('./lib/payment-listener')(lnPath, model);
          app = require('express')();
          app.set('port', process.env.PORT || 9112);
          app.set('host', process.env.HOST || 'localhost');
          app.set('trust proxy', process.env.PROXIED || 'loopback');
          app.use(require('morgan')('dev'));
          app.use(require('body-parser').json());
          app.use(require('body-parser').urlencoded({
            extended: true
          }));
          process.env.ALLOW_CORS && app.use(function (req, res, next) {
            res.set('Access-Control-Allow-Origin', process.env.ALLOW_CORS);
            res.set('Access-Control-Allow-Headers', 'Content-Type, Accept');
            res.set('Access-Control-Allow-Methods', 'GET, DELETE, POST');
            next();
          });
          app.get('/info', auth, (0, _promiseWrap["default"])( /*#__PURE__*/function () {
            var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(req, res) {
              return regeneratorRuntime.wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      _context.t0 = res;
                      _context.next = 3;
                      return ln.getinfo();

                    case 3:
                      _context.t1 = _context.sent;
                      return _context.abrupt("return", _context.t0.send.call(_context.t0, _context.t1));

                    case 5:
                    case "end":
                      return _context.stop();
                  }
                }
              }, _callee);
            }));

            return function (_x, _x2) {
              return _ref2.apply(this, arguments);
            };
          }()));

          require('./invoicing')(app, payListen, model, auth, lnconf);

          require('./checkout')(app, payListen);

          require('./sse')(app, payListen, auth);

          require('./webhook')(app, payListen, model, auth);

          require('./websocket')(app, payListen, apiToken);

          app.use(function (err, req, res, next) {
            return err.name == 'LightningError' ? res.status(err.status || 400).send(err.toString()) : next(err);
          });
          server = app.listen(app.settings.port, app.settings.host, function (_) {
            console.log("HTTP server running on ".concat(app.settings.host, ":").concat(app.settings.port));
            app.emit('listening', server);
          });

        case 24:
        case "end":
          return _context2.stop();
      }
    }
  }, _callee2);
}))();

process.on('unhandledRejection', function (err) {
  throw err;
});
process.on('SIGTERM', function (err) {
  console.error('Caught SIGTERM, shutting down');
  process.exit(0);
});