"use strict";

var _promiseWrap = _interopRequireDefault(require("./lib/promise-wrap"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var debug = require('debug')('lightning-charge'); // maximum wait time for long-polling


var maxWait = +process.env.MAX_WAIT || 600;

module.exports = function (app, payListen, model, auth, lnconf) {
  var newInvoice = model.newInvoice,
      fetchInvoice = model.fetchInvoice,
      listInvoices = model.listInvoices,
      delInvoice = model.delInvoice,
      delExpired = model.delExpired;
  app.on('listening', function (server) {
    return server.timeout = maxWait * 1000 + 500;
  });
  app.param('invoice', (0, _promiseWrap["default"])( /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(req, res, next, id) {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return fetchInvoice(req.params.invoice);

            case 2:
              req.invoice = _context.sent;

              if (req.invoice) {
                _context.next = 5;
                break;
              }

              return _context.abrupt("return", res.sendStatus(404));

            case 5:
              next();

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x, _x2, _x3, _x4) {
      return _ref.apply(this, arguments);
    };
  }()));
  app.get('/invoices', auth, (0, _promiseWrap["default"])( /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(req, res) {
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.t0 = res;
              _context2.next = 3;
              return listInvoices();

            case 3:
              _context2.t1 = _context2.sent;
              return _context2.abrupt("return", _context2.t0.send.call(_context2.t0, _context2.t1));

            case 5:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function (_x5, _x6) {
      return _ref2.apply(this, arguments);
    };
  }()));
  app.get('/invoice/:invoice', auth, function (req, res) {
    return res.send(req.invoice);
  });
  app.post('/invoice', auth, (0, _promiseWrap["default"])( /*#__PURE__*/function () {
    var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(req, res) {
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              _context3.t0 = res.status(201);
              _context3.next = 3;
              return newInvoice(req.body);

            case 3:
              _context3.t1 = _context3.sent;
              return _context3.abrupt("return", _context3.t0.send.call(_context3.t0, _context3.t1));

            case 5:
            case "end":
              return _context3.stop();
          }
        }
      }, _callee3);
    }));

    return function (_x7, _x8) {
      return _ref3.apply(this, arguments);
    };
  }()));
  app.get('/invoice/:invoice/wait', auth, (0, _promiseWrap["default"])( /*#__PURE__*/function () {
    var _ref4 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(req, res) {
      var expires_in, timeout, paid;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              if (!(req.invoice.status == 'paid')) {
                _context4.next = 2;
                break;
              }

              return _context4.abrupt("return", res.send(req.invoice));

            case 2:
              if (!(req.invoice.status == 'expired')) {
                _context4.next = 4;
                break;
              }

              return _context4.abrupt("return", res.sendStatus(410));

            case 4:
              expires_in = req.invoice.expires_at - (Date.now() / 1000 | 0);
              timeout = Math.min(+req.query.timeout || 300, expires_in, maxWait);
              _context4.next = 8;
              return payListen.register(req.invoice.id, timeout * 1000);

            case 8:
              paid = _context4.sent;
              if (paid) res.send(paid);else res.sendStatus(timeout == expires_in ? 410 : 402); // @TODO remove listener on client disconnect

            case 10:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function (_x9, _x10) {
      return _ref4.apply(this, arguments);
    };
  }()));
  app["delete"]('/invoice/:invoice', auth, (0, _promiseWrap["default"])( /*#__PURE__*/function () {
    var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(req, res) {
      return regeneratorRuntime.wrap(function _callee5$(_context5) {
        while (1) {
          switch (_context5.prev = _context5.next) {
            case 0:
              _context5.next = 2;
              return delInvoice(req.params.invoice, req.body.status);

            case 2:
              res.sendStatus(204);

            case 3:
            case "end":
              return _context5.stop();
          }
        }
      }, _callee5);
    }));

    return function (_x11, _x12) {
      return _ref5.apply(this, arguments);
    };
  }())); // Enable automatic cleanup for expired invoices if enabled on c-lightning,
  // using the same configurations.
  // Disabled until the following issues are addressed:
  // https://github.com/ElementsProject/lightning/issues/2180
  // https://github.com/ElementsProject/lightning/issues/2181

  /*
  if (lnconf['autocleaninvoice-cycle'] && lnconf['autocleaninvoice-expired-by']) {
    const cycle = lnconf['autocleaninvoice-cycle'] * 1000
        , ttl   = lnconf['autocleaninvoice-expired-by']
     debug(`Running autoclean job every ${cycle/1000}s to delete invoices expired over ${ttl}s ago`)
     ;(async function expiryJob() {
      debug('Cleaning up expired invoices')
      await delExpired(ttl)
      setTimeout(expiryJob, cycle)
    })()
  }
  */
};