"use strict";

var _superagent = _interopRequireDefault(require("superagent"));

var _promiseWrap = _interopRequireDefault(require("./lib/promise-wrap"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

require('superagent-proxy')(_superagent["default"]);

var debug = require('debug')('lightning-charge'); // if none if set, will fallback to using HTTP(S)_PROXY or ALL_PROXY.
// see https://github.com/Rob--W/proxy-from-env


var HOOK_PROXY = process.env.HOOK_PROXY;

module.exports = function (app, payListen, model, auth) {
  var addHook = model.addHook,
      getHooks = model.getHooks,
      logHook = model.logHook;
  app.post('/invoice/:invoice/webhook', auth, (0, _promiseWrap["default"])( /*#__PURE__*/function () {
    var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(req, res) {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              if (!(req.invoice.status == 'paid')) {
                _context.next = 2;
                break;
              }

              return _context.abrupt("return", res.sendStatus(405));

            case 2:
              if (!(req.invoice.status == 'expired')) {
                _context.next = 4;
                break;
              }

              return _context.abrupt("return", res.sendStatus(410));

            case 4:
              _context.next = 6;
              return addHook(req.params.invoice, req.body.url);

            case 6:
              res.sendStatus(201);

            case 7:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }()));
  payListen.on('payment', /*#__PURE__*/function () {
    var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(invoice) {
      var hooks;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return getHooks(invoice.id);

            case 2:
              hooks = _context2.sent;
              debug('Calling webhooks for %s: %o', invoice.id, hooks.map(function (h) {
                return h.url;
              }));
              Promise.all(hooks.map(function (hook) {
                return _superagent["default"].post(hook.url).proxy(HOOK_PROXY).type('json').send(invoice).then(function (res) {
                  return res.ok ? res : Promise.reject(new Error('invalid status code ' + res.status));
                }).then(function (res) {
                  return logHook(hook.id, null, res);
                })["catch"](function (err) {
                  return logHook(hook.id, err);
                });
              }));

            case 5:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    return function (_x3) {
      return _ref2.apply(this, arguments);
    };
  }());
};