"use strict";

var _ws = _interopRequireDefault(require("ws"));

var _basicAuth = _interopRequireDefault(require("basic-auth"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

module.exports = function (app, payListen, apiToken) {
  var verifyClient = function verifyClient(info) {
    var cred = (0, _basicAuth["default"])(info.req);
    return cred && cred.name === 'api-token' && cred.pass === apiToken;
  };

  app.on('listening', function (server) {
    var wss = new _ws["default"].Server({
      server: server,
      path: '/ws',
      verifyClient: verifyClient
    });
    payListen.on('payment', function (inv) {
      var msg = JSON.stringify(inv);
      wss.clients.forEach(function (client) {
        return client.readyState === _ws["default"].OPEN && client.send(msg);
      });
    });
  });
};